#if !defined(LECTURE372_OBJECT_2D)
#define LECTURE372_OBJECT_2D

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MyMath.h"

typedef enum {CONVEX_POLYGON, ELLIPSOID} ObjectType;

// A virtual class for a 2D object
// No instances of this class can be constructed
class CObject2df
{
public:
	CObject2df(){ r=1.0; g=0.0; b=0.0;}
	virtual ~CObject2df(){}
	void setColour(float r, float g, float b);
	virtual void draw()=0;
	ObjectType type;
protected:
	float r,g,b;		// Colour
};

class CConvexPolygon2df:public CObject2df
{
public:
	CConvexPolygon2df();
	CConvexPolygon2df(int n, CVec2df*& vertices);
	void draw();
	virtual ~CConvexPolygon2df();
protected:
	CVec2df* vertices;	// Vertices
	int numVertices;	// number of vertices
};

//////////////////////////////////////////////////////////////
// Question 3d:											    //
// Please insert here the code for the class CEllipsoid2df	//
//////////////////////////////////////////////////////////////


#endif // !defined(LECTURE372_OBJECT_2D)
