#if !defined(LECTURE372_CARD)
#define LECTURE372_CARD

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Object2df.h"

const int CARD_WIDTH=100;
const int CARD_HEIGHT=140;

typedef enum {SHOW_FRONT, SHOW_BACK, INVISIBLE} CardStateType;

class CCard
{
public:
	CCard(void);
	~CCard(void);
	void draw();
	void init(int, CObject2df*);
	bool isSelected(int, int);
	CardStateType cardState;
	bool sameCard(CCard& card){ return card.objectPtr==objectPtr;}
private:
	int cx, cy;
	CObject2df *objectPtr;
};

#endif // !defined(LECTURE372_CARD)
